'**********************************************************************
'****     CW-KEYER MIT CQ-TEXT FR DIE C-CONTROL MICRO            *****
'**********************************************************************
' CONRAD ELECRONIC SEPT.03 (DIE HARD)
' -  Paddle Anschluss an Port3 (Punkt) und Port2 (Strich)
' -  Geschwindigkeitseinstellung ber tastenbedientes Men
' -  Punkt und Strich Speicherung
' -  eine feste CQ Schleife

'          (GND)    --------------PADDLE STRICH
'          Port2   -----------I
'          Port3   -----------I
'          (GND)    --------------PADDLE PUNKT
'
' - Port1 ist der Ausgang und wird an den Transceiver angeschlossen
' - Die Ports 3 u. 2 bentigen einen PULLUP Widerstand (ca. 10k)
'--------------------------------------------------------------------------------------
'   Das Programm ist ein ganz normaler Keyer mit 7 Stufen einstellbarer Geschwindigkeit
'   und einem festen CQ-Text.
'   Drcken Sie BEIDE Paddles etwa 1s um das Mene zu aktivieren
'   Whlen Sie geben Sie einen Punkt um das Men fr die Geschwindigkeit
'   zu aktivieren, einen Strich fr die CQ Textauswahl.
'
'   MENUE: GESCHWINDIGKEIT
'   Die aktuele Stufe der Geschwindigkeit wird als Balken mit den 3 LEDS angezeigt
'   und zwar binr von Stufe 1 (langsam) bis Stufe 7 (schnell)
'
'   Geben Sie jeweils einen Punkt um die Stufe um eins zu erhhen
'   Geben Sie jeweils einen Strich um die Stufe um eins zu erniedrigen.
'   Das Men wird bei Inaktivitt nach 2s verlassen.
'
'   MENUE: TEXTAUSWAHL
'   Der beschrnkete Speicher lsst leider nur einen Text zu.
'   Nach Anwahl des Mens TEXTAUSWAHL beginnt die Sendung

'   Brechen Sie die Sendung mit dem STRICH-Paddle ab.
'   Der CQ-Text ist in der Geschwindigkeit fest eingestellt.
'   Und....es ist mein Cq-Text, ndern Sie ihn bitte
'**********************************************************************
'--------------------------
'------ I/O PORTS ---------
'--------------------------
define strich port[2]
define punkt  port[3]'TASTER
define out    port[1]
define LED1   port[4]
define LED2   port[5]
define LED3   port[6]
define LED4   port[6]
'--------------------------
'---- SYSTEM MEMORY -------
'--------------------------
define f       byte[1]
define l       byte[2]
define k       byte[3]
define pflag   byte[4]
define sflag   byte[5]
define speed   byte[6]
define w       byte[7]
define const1  byte[8]
define const2  byte[9]
define const3  byte[10]
define timeout byte[11]
define select  byte[12]
define cqselect byte[13]
define delay    byte[14]
'--------------------------
'--- SYSTEM CONSTANTS -----
'--------------------------
f =100                     'Frequenz Mithrton
const1=25
const2=3
const3=1
out=off
cqselect=1
'------------- DEFAULT SPEED -------------------
speed=10 'KEYER
k=3:l=9 'AUTO CQ
#ttt
led1=on:pause 10:led1=off
led2=on:pause 10:led2=off
led3=on:pause 10:led3=off

gosub show_speed
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'IIIIIII     PROGRAM MAIN LOOP    IIIIIIIIIIIIII
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
#abfrage
'----------------------------------------------
'--------- CHECK MENUE ENTER  -----------------
'----------------------------------------------
if (punkt or strich)=off then goto setup
'------ PROCESS PADDLE ACTUATION---------------
if sflag   then gosub gibstrich
if pflag   then gosub gibpunkt
if not strich then gosub gibstrich
if not punkt then gosub gibpunkt
goto abfrage
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII

'IIIIIIIIIIII DOT GENERATOR IIIIIIIIIIIIIIIIIIII
#gibpunkt
'---------------- DOT ACTIVE  ------------------
pflag=0:out=on
for w=1 to speed
for delay=1 to 20
if not strich then sflag=1
next
#S_MEM1
next
out=off
'--------------- DOT PAUSE ACTIVE --------------
for w=1 to speed
for delay=1 to 20
if not strich then sflag=1
next
#S_MEM2
next
return

'IIIIIIIIIIII DASH GENERATOR IIIIIIIIIIIIIIIIIII
#gibstrich
'--------------- DASH ACTIVE -------------------
sflag=0:out=on
for w=1 to 3*speed
for delay=1 to 20
if not punkt then pflag=1
next
#P_MEM1
next
out=off
'--------------- DASH PAUSE ACTIVE --------------
for w=1 to speed
for delay=1 to 20
if not punkt then pflag=1
next
#P_MEM2
next
return

'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'IIIIIIIIIIIIIIIII SETUP MENUE IIIIIIIIIIIIIIIIII
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
#setup
'------- RETURN IF ALREADY RELEASED -------------
pause 1:if (punkt or strich)=on then goto abfrage
pause 1:if (punkt or strich)=on then goto abfrage
pause 1:if (punkt or strich)=on then goto abfrage
pause 1:if (punkt or strich)=on then goto abfrage
pause 1:if (punkt or strich)=on then goto abfrage
pause 1:if (punkt or strich)=on then goto abfrage
'------- WAIT FOR BOTH PADDLES RELEASED ---------
#wfr
if (punkt and strich)=off then goto wfr
pause 5
'----------- WAIT FOR SELECTION -----------------
#wfs
if not strich then goto cqtext_enter
if not punkt then goto speed_enter
goto wfs
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'IIIIIIIIIIIIII  SPEED SETUP   IIIIIIIIIIIIIIIIII
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
#speed_enter
'---------- WAIT FOR RELEASE -------------------
timeout=0
if not punkt then goto speed_enter
'----------  CHECK INC/DEC --------------------
#INC_DEC
if not punkt then goto INC_SPEED
if not strich then goto DEC_SPEED
pause 2:timeout=timeout+1
if timeout=50 then goto speed_exit
goto INC_DEC
'---------- INCREMENT SPEED --------------------
'LIMIT IS 8
#INC_SPEED
speed=speed-1
if speed=7 then speed=8
gosub show_speed
#SWFR1
timeout=0
if not punkt then goto SWFR1
goto INC_DEC
'--------- DECREMENT SPEED ---------------------
'LIMIT IS 14
#DEC_SPEED
speed=speed+1
if speed=15 then speed=14
gosub show_speed
#SWFR2
timeout=0
if not strich then goto SWFR2
goto INC_DEC
'--------- EXIT SPEED SETTING ------------------
#speed_exit
if speed < 15 then k=3 else k=4
if speed < 15 then l=9 else l=12
if speed < 8 then k=2
if speed < 8 then l=6
goto abfrage
'--------- DISPLAY CURRENT SPEED ---------------
' L3     - - x
' L2     - x x
' L1     x x x
' SPEED 10 9 8
#show_speed
LED1=off:LED2=off:LED3=off
if speed =14 then LED1=on  '1
if speed=13 then LED2=on   '2
if speed=12 then goto s12  '3
if speed=11 then LED3=on   '4
if speed=10 then goto s10  '5
if speed=9 then goto s9    '6
if speed=8 then goto s8    '7
return
#S12
LED1=on:LED2=on:return
#S10
LED3=on:LED1=on:return
#S9
LED3=on:LED2=on:return
#S8
LED3=on:LED2=on:LED1=on:return

'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'IIIIIIIIIIII  CQ-CALL SETUP   IIIIIIIIIIIIIIIIII
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
#cqtext_enter
'--------- WAIT FOR RELEASE --------------------
timeout=0:gosub show_text
if not strich then goto cqtext_enter
goto cqtext1
'-------- SHOW TEXT SELECTION --------------------
#show_text
LED1=off:LED2=off:LED3=off:LED4=off
LED1=on:pause 5:LED1=off
return
'---------- EXIT CQ PLAY -------------------------
#cqtext_exit
gosub show_speed:goto abfrage
'----------- CQ TEXT 1 -----------------------
#cqtext1
gosub cq:if not strich then goto cqtext_exit
gosub cq:if not strich then goto cqtext_exit
gosub cq:if not strich then goto cqtext_exit
gosub de:if not strich then goto cqtext_exit
gosub rufzeichen:if not strich then goto cqtext_exit
gosub rufzeichen:if not strich then goto cqtext_exit
gosub cq:if not strich then goto cqtext_exit
gosub pse:if not strich then goto cqtext_exit
gosub k:if not strich then goto cqtext_exit
for cqselect= 1 to 200
pause 1:if not strich then goto cqtext_exit
next
goto cqtext1

'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
#cq
out=on:pause l:out=off:pause k
out=on:pause k:out=off:pause k
out=on:pause l:out=off:pause k
out=on:pause k:out=off:pause l
'----------
out=on:pause l:out=off:pause k
out=on:pause l:out=off:pause k
out=on:pause k:out=off:pause k
out=on:pause l:out=off:pause l
pause 3*l
return
'------------------------------------------------
#de
out=on:pause l:out=off:pause k                        'D
out=on:pause k:out=off:pause k
out=on:pause k:out=off:pause l
'---------
out=on:pause k:out=off:pause l                        'E
pause 3*l
return
'------------------------------------------------
#rufzeichen
out=on:pause l:out=off:pause k                        'D
out=on:pause k:out=off:pause k
out=on:pause k:out=off:pause l
'-----------
out=on:pause k:out=off:pause k                        'L
out=on:pause l:out=off:pause k
out=on:pause k:out=off:pause k
out=on:pause k:out=off:pause l
'-----------
out=on:pause k:out=off:pause k                         '4
out=on:pause k:out=off:pause k
out=on:pause k:out=off:pause k
out=on:pause k:out=off:pause k
out=on:pause l:out=off:pause l
'----------
out=on:pause k:out=off:pause k                         'R
out=on:pause l:out=off:pause k
out=on:pause k:out=off:pause l
'----------
out=on:pause l:out=off:pause k                          'C
out=on:pause k:out=off:pause k
out=on:pause l:out=off:pause k
out=on:pause k:out=off:pause l
'----------
out=on:pause k:out=off:pause k                          'L
out=on:pause l:out=off:pause k
out=on:pause k:out=off:pause k
out=on:pause k:out=off:pause l
pause 3*l
return
'------------------------------------------------
#pse
out=on:pause k:out=off:pause k
out=on:pause l:out=off:pause k
out=on:pause l:out=off:pause k
out=on:pause k:out=off:pause l
'----------
out=on:pause k:out=off:pause k
out=on:pause k:out=off:pause k
out=on:pause k:out=off:pause l
'----------
out=on:pause k:out=off:pause l
pause 3*l
return
'------------------------------------------------
#k
out=on:pause l:out=off:pause k
out=on:pause k:out=off:pause k
out=on:pause l:out=off:pause l
return
