'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'IIIIIIIIIIIIIII      DEMO ZUR C-CONTROL MICRO             IIIIIIIIIIII
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'(by DIE HARD  10.04)
'
' ANWENDUNG:   IIC-BUS TASTATUR (19 83 56) MIT PCF8574 - DECODIERUNG -
'              IIC-BUS LCD (19 83 30) MIT PCF8574 - ANSTEUERUNG -
'-----------------------------------------------------------------------
' Sie sehen hier die Anwendung der C-Control MICRO mit einer PCF8574
' Porterweiterung fr eine Tastatut und ein LCD.
' Der PCF8574 befindet sich auf dem IIC-BUS TASTATUR MODUL
' und auf dem LCD Modul. Es befinden sich beide Treiber auf in diesem 
' Programm. Der Treiber fr das LCD ist im Wesentlichen der gleiche wie
' in den Beispielen zum IIC-BUS LCD Modul
'
' Der Treiber fr den TASTATURDECODER und die Ansteuerung des LCD hat zusammen
' etwa 600 Bytes, sodass fr das Anwenderpogramm noch gengend Platz ist.
'-----------------------------------------------------------------------
' Der PCF8574 wird ber einen IIC-Bus angesteuert der hier als BASIC
' -Treiber ausgefhrt ist. Der IIC-Bus bentigt zwei Ports stellt aber
' selbst 8 Ports zur Verfgung.
' Die Ports fr den IIC-Bus sind hier PORT2=SDA und PORT5=SCL
' Sie knnen natrlich mehrere PCF5478 an der MICRO betreiben.
' Dazu mssen die Bausteine natrlich unterschiedliche Adressen haben.
'-----------------------------------------------------------------------
' In diesem Beispiel wird ein PCF8574 verwendet um eine 4x4 Matrix-Tastatur
' zu decodieren. Der Aufruf von GOSUB KEYDECODE liefert in der Variablen
' KEY den Tastencode der Matrix-Tastatur zurck
' Das Programm zeigt am LCD den Tastencode 0 bis 9 fr die jeweiligen Ziffern
' und die Codes 11 bis 16 fr Funktionstasten A bis F.
' Beachten Sie dass die beiden PCF8574 jeweils auf unterschiedlichen Adressen
' laufen mssen.
'
' In diesem Beispiel:
' PCF8574 TASTATUR DEVICE READ/WRITE ADDRESS
' define WADDRESS &B01001100
' define RADDRESS &B01001101
' PCF8574 LCD DEVICE WRITE ADDRESS
' define LCDADDR  &B01001110
'--------------------------------------------------------------------------
' Sie knnen SDA und SCL natrlich auch auf andere Digitalports legen,
' wenn Ihre Anwendung das erfordert.
'--------------------------------------------------------------------------
'--------------------------
'------ I/O PORTS ---------
'--------------------------
'--- IIC INTERFACE  -------
define SDA      port[2]
define SCL      port[5]
'define SDA      port[9]
'define SCL      port[10]
'---- PROGRAMM ------------
define LAMP     port[16]
'--------------------------
'------ SYSTEM MEMORY -----
'--------------------------
'--- IIC INTERFACE  -------
define IICDATA      byte[1]
define DATABYTE     byte[2]
define ADDRESS      byte[3]
define MASK         byte[4]
'---- MATRIX DECODER ------
define OFFSET       byte[5]
define KEY          byte[6]
'----- LCD DRIVER ---------
define BUF          byte[7]
define LCDDATA      byte[8]
'------- PROGRAM ----------
define COUNTER      byte[9]
'--- DEZIMAL CONVERTER ----
define value        byte[10]
define hunderter    byte[11]
define zehner       byte[12]
define einer        byte[13]


'- PCF8574 TASTATUR DEVICE READ/WRITE ADDRESS --
define WADDRESS &B01001100
define RADDRESS &B01001101
'------ PCF8574 LCD DEVICE WRITE ADDRESS -------
define LCDADDR  &B01001110
'---- ZEICHENSATZ DEFINITION -------------
define Z0&H30:define Z1&H31:define Z2&H32:define Z3&H33
define Z4&H34:define Z5&H35:define Z6&H36:define Z7&H37
define Z8&H38:define Z9&H39
define A&H41:define B&H42:define C&H43:define D&H44
define E&H45:define F&H46:define G&H47:define H&H48
define I&H49:define J&H4A:define K&H4B:define L&H4C
define M&H4D:define N&H4E:define O&H4F:define P&H50
define Q&H51:define R&H52:define S&H53:define T&H54
define U&H55:define V&H56:define W&H57:define X&H58
define Y&H59:define Z&H5A:define BLK&H20

'---------- IICBUS INIT ------------------
SDA=on:SCL=on:pause 1


gosub lcd_init:pause 20
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'II   MATRIX KEY-DECODE AND DISPLAY     II
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
pause 20

gosub lcd_init
#LOOP
'----- WRITE CHARACTERS LINE 1 ---------------
LCDDATA=4:gosub L1_GOTOPOS    'LINE 1 POS 4
LCDDATA=K:gosub lcd_writechar
LCDDATA=E:gosub lcd_writechar
LCDDATA=Y:gosub lcd_writechar
LCDDATA=BLK:gosub lcd_writechar
gosub KEYDECODE:VALUE=KEY:gosub SHOWCOUNTER
LCDDATA=BLK:gosub lcd_writechar
LCDDATA=BLK:gosub lcd_writechar
LCDDATA=BLK:gosub lcd_writechar
goto LOOP

'IIIIIIIIIIIII UNTERPROGRAMME IIIIIIIIIIIIIIIIIIIIIII
#SHOWCOUNTER
hunderter=value/100
LCDDATA=hunderter+&H30:gosub LCD_WRITECHAR
zehner=(value-(hunderter*100))/10:LCDDATA=zehner+&H30:gosub LCD_WRITECHAR
einer=value-(hunderter*100)-(zehner*10):LCDDATA=einer+&H30:gosub LCD_WRITECHAR
return
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII




'HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
'HHHHHHHHHH TASTATURDECODER HHHHHHHHHHHHHHHH
'HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
#KEYDECODE
KEY=255
'--------- DECODE COLUMN 1    1-5-9-C     --
OFFSET=0:DATABYTE=&B11101111
gosub DEC:if KEY<>255 then return
'--------- DECODE COLUMN 2    2-6-0-D     --
DATABYTE=&B11011111
gosub DEC:if KEY<>255 then return
'--------- DECODE COLUMN 3    3-7-A-E     --
DATABYTE=&B10111111
gosub DEC:if KEY<>255 then return
'--------- DECODE COLUMN 2    4-8-B-F    --
DATABYTE=&B01111111
gosub DEC:return
'------------------------------------------
#DEC
ADDRESS=WADDRESS:gosub WRITEBYTE
ADDRESS=RADDRESS:gosub READBYTE:DATABYTE=DATABYTE and &H0F
if DATABYTE=&B00001110 then KEY=1+OFFSET
if DATABYTE=&B00001101 then KEY=5+OFFSET
if DATABYTE=&B00001011 then KEY=9+OFFSET
if DATABYTE=&B00000111 then KEY=13+OFFSET
IF KEY=10 THEN KEY=0
OFFSET=OFFSET+1
return
'HHHHHHHHHH IIC-BUS DRIVER HHHHHHHHHHHHHHHHH
'-------------------------------------------
'-- WRITE BYTE IN OUTBYTE TO PCF8574  ------
'-------------------------------------------
#WRITEBYTE
gosub IICSTART:IICDATA=ADDRESS:gosub IICSEND
IICDATA=DATABYTE:gosub IICSEND:gosub IICSTOP:return
'-------------------------------------------
#IICSTART
SDA=off:SCL=off:return
#IICSTOP
SDA=off:SCL=on:SDA=on:return
#IICSEND
MASK=&H80
#OUTSHIFT
SDA=(IICDATA and MASK):SCL=on:SCL=off
MASK=MASK shr 1:if MASK<>0 then goto OUTSHIFT
'---- 9th CLOCK FOR ACKNOWLEDGE ----------
#ACKN
deact SDA:SCL=on:SCL=off:SDA=off:return

'-------------------------------------------
'-- READ BYTE FROM PCF8574 INTO OUTBYTE  ---
'-------------------------------------------
#READBYTE
gosub IICSTART:IICDATA=ADDRESS:gosub IICSEND
gosub IICREAD:gosub IICSTOP:return
#IICREAD
deact SDA:DATABYTE=0:MASK=&H80
#INSHIFT
SCL=on:if SDA=on then DATABYTE=(DATABYTE or MASK)
SCL=off:MASK=MASK shr 1:if MASK <>0 then goto INSHIFT
'---- 9th CLOCK FOR ACKNOWLEDGE ----------
goto ACKN
'---------------------------------------
'------------- LCD ROUTINES -------------
'----------------------------------------
#LCD_INIT
ADDRESS=LCDADDR
DATABYTE=0:gosub WRITEBYTE
LCDDATA=&H38:gosub LCD_WRITECMD
DATABYTE= &B00000010:gosub WRITEBYTE '$02 to LCD
DATABYTE= &B01000010:gosub WRITEBYTE '$02 with CLOCK
DATABYTE= &B00000010:gosub WRITEBYTE
LCDDATA=&H28:gosub LCD_WRITECMD
LCDDATA=&H0C:gosub LCD_WRITECMD
#LCD_CLR
LCDDATA=&H02:gosub LCD_WRITECMD
LCDDATA=&H01:gosub LCD_WRITECMD
return
#L1_GOTOPOS
LCDDATA=LCDDATA +&H7F:goto LCD_WRITECMD
#L2_GOTOPOS
LCDDATA=LCDDATA +&HBF:goto LCD_WRITECMD
#LCD_WRITECMD
BUF = off:goto LCD_WRITE
#LCD_WRITECHAR
BUF = &B00100000
#LCD_WRITE
ADDRESS=LCDADDR
'--------- WRITE HI NIBBLE -------------
DATABYTE=BUF or (LCDDATA shr 4):gosub WRITEBYTE      'DATA TO PORT
DATABYTE=DATABYTE or &B01000000:gosub WRITEBYTE           'STROBE HI
DATABYTE=DATABYTE and &B10111111:gosub WRITEBYTE          'STROBE LO
'--------- WRITE LO NIBBLE -------------
DATABYTE=BUF or (LCDDATA and &H0F):gosub WRITEBYTE'DATA TO PORT
DATABYTE=DATABYTE or &B01000000:gosub WRITEBYTE           'STROBE HI
DATABYTE=DATABYTE and &B10111111:gosub WRITEBYTE          'STROBE LO
return


