'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'IIIIIII  DEMO ZUM BASIC-COMPUTER UNIT MICRO     (by DIE HARD)  IIIII
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'--------------------------------------------------------------------
' Beispiel zum BASIC-COMPUTER    mit dem Programmer/Application-Board
'--------------------------------------------------------------------
' ANWENDUNG:    4 DIGIT IIC-BUS LED-DISPLAY 198344          (TREIBER SAA1064)
'
'--------------------------------------------------------------------
' Einer der vielen erhltlichen Bausteine mit IIC-Bus
' Interface ist der 4 DIGIT LED DISPLAY TREIBER SAA1064. Er ist der Baustein
' der die 4 DIGIT 7 SEGMENTANZEIGE der LED-Anzeige ansteuert.
' Er hat ein verhltnismssig einfaches Protokoll das auch in BASIC
' recht einfach in die Treibersoftware fr diesn Baustein umgesetzt werden kann.
'
' <START><ADDRESS><INSTRUCTION><CONTROL><DIGIT1><DIGIT2><DIGIT3>DIGIT<4><STOP>
'
' Die Adresse besteht aus einem festen, nicht vernderbaren Anteil und
' einem vom Benutzer whlbaren Teil (zwei Bits). Das letzte Bit
' legt fest ob eine READ (Eingabe) oder WRITE (Ausgabe) ber den SAA1064
' erfolgt
' In diesem Beispiel hat der SAA1064 die Adresse 3 (alle Bits auf HI),
' alle Jumper abgezogen.
' Allerdings ist beim diesem Baustein die interne Adressdecodierung 
' etwas anders als blich. Das Modul hat deshalb 4 Jumper die dem
' Modul die Adresse 0 bis 3 zuweisen.
' Es darf jeweils nur ein Jumper gesteckt sein.
' J1   A0=0, A1=0
' J2   A0=1, A1=0
' J3   A0=0, A1=1
' J4   A0=1, A1=1
' Damit ergibt sich fr eine READ-Operation folgender Wert:
'
' 0 1 1 1 0 x x 1       READ-Operation
' I------I-----I-I
' FIX ADR  ADR  R/W
'
' Fr eine WRITE-Operation ist das letzte Bit LO und es ergibt sich
' folgender Wert:
'
' 0 1 1 1 0 x x 0       WRITE-Operation
' I------I-----I-I
' FIX ADR  ADR  R/W
'
' x sind die mit Jumper auf 0 setzbaren Adressbits.
' In diesem Beispiel wird angenommen, dass kein Jumper gesteckt ist. Die
' Adresse ist damit 118= $76 = 01110110

' Das INSTRUCTION-BYTE legt fest mit welches der internen Register
' zuerst beschriebnen wird. In unserem Beispiel ist das INSTRUCTION BYTE
' Null, das bedeutet dass nach dem INSTRUCTION BYTE das KONTROLLREGISTER
' und danach die DATENREGISTER der vier Digits beschrieben werden.
' Das KONTROLLREGISTER legt den LED Modus (hier Multiplex)und die LED
' Helligkeit fest.
'
' Die Zuweisung der Segmente zum jeweiligen Bit sind so:
'        a
'      f   b              xgfedcba (a=bit0)
'        g
'      e   c
'        d
' Beispiel:
' Eine 1 wird durch die Segmente bc dargestellt und die entsprechenden Bits sind
' log 1, die anderen 0 -> 00000110 =&H06
'
' Um Ihnen die Arbeit mit dem Treiber zu vereinfachen
' brauchen Sie sich aber um diese Angelegenheiten nicht zu kmmern,
' da enstprechende Unterprogramme im Treiber vorhanden sind.
'-----------------------------------------------------------------------
' SCHNITTSTELLE ZUM TREIBER
' Ihre Schnittstelle zum LED Treiber ist die Variable BRIGHTNES der Sie
' die vordefinierten Werte BRIGHT0 bis BRIGHT7 zuweisen knnnen.
' BRIGHT0 ist vollstndiege Dunkelheit, die LEDs sind also aus.
' Der Aufruf des Unterprogramms GOSUB SHOW_COUNTER bringt den Inhalt
' der Wortvariablen zur Anzeige.
' Ausserdem sind einige Buchsatben definiert um kurze Meldungen wie
' z.B. "Err" anzeigen zu knnen.
'-----------------------------------------------------------------------
' INNERHALB DES TREIBERS
' Die Variablen DIGIT1 bis DIGIT4 sind der Inhalt der am LED Display
' dargestellt werden soll. Natrlich muss der Inhalt des DIGITS fr
' die LED Anzeige 7-Segment codiert sein. Das Unterprogramm DECODE
' wandelt ein dezimales Digit (bergabe/Rckgabe in der Variablen DECODER)
' in den entsprechenden 7-Segment-Code
' Nach der Berechning des Displayinhalts aus der Variablen COUNTER wird mit Aufruf des
' Unterprogramms GOSUB SENDBUF der komplette Datenrahmen zum Display bertragen.
'-----------------------------------------------------------------------
' Der IIC-Bus liegt an PORT 2 (SDA) und PORT 5 (SCL)
'------------------------------------------------------------------------
' BEISPIEL
' Das Beispiel zeigt einen laufenden Zhler bis 255 und rdy nach Ablauf
' des Programms
'---------------------------------------------------------------------
' ACHTUNG:
' Das LED-Display bentigt bei max. Helligkeit sehr viel Strom
' Die Khlung des Spannungsreglers auf dem Application-Board ist
' dafr nicht ausreichend. Betreiben Sie das Display mit BRIGHT2,
' wenn keine zustzliche Khlung fr den Spannungsregler auf dem
' Application-Board vorgesehen ist.
'-----------------------------------------------------------------------

'--------------------------
'------ I/O PORTS ---------
'--------------------------
'--- IIC INTERFACE  -------
define SDA      port[2]
define SCL      port[5]

'---- PROGRAMM ------------
define LIGHT          port[16]
'--------------------------
'---- SYSTEM MEMORY -------
'--------------------------
define BRIGHTNES   byte[1]
define DIGIT1      byte[2]
define DIGIT2      byte[3]
define DIGIT3      byte[4]
define DIGIT4      byte[5]
'-------------------------
define IICDATA     byte[6]
define MASK        byte[7]
define DECODE      byte[8]
'- LCD DRIVER APP BOARD ---
define lcd_buf   byte[9]
define lcd_param byte[10]
define COUNTER     byte[11]
define HUNDERTER   byte[12]
define ZEHNER      byte[13]
define EINER       byte[14]

'-------------------------
define LEDREAD     119
define LEDWRITE    118
'----- LED HELLIGKEIT -----
define BRIGHT0 &H07
define BRIGHT1 &H17
define BRIGHT2 &H27
define BRIGHT3 &H37
define BRIGHT4 &H47
define BRIGHT5 &H57
define BRIGHT6 &H67
define BRIGHT7 &H77
'-------------------------
define MINUS &H40
define A &H77
define B &H7F
define C &H39
define d &H5E
define E &H79
define F &H71
define G &H7D
define H &H76
define I &H06
define J &H0F
define L &H38
define n &H54
define o &H5C
define P &H73
define r &H50
define S &H6D
define t &H78
define U &H3E
define y &H6E




#INIT
SDA=on:SCL=on


'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'III           DEMO LAUFENDER ZHLER                   II
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
BRIGHTNES=BRIGHT2                              'Heligkeit
'----------- TEST - ALL SEGMENTS ON --------------------
gosub SHOW_TEST:pause 50
'----------- BLANK - ALL SEGMENTS OFF ------------------
gosub SHOW_BLANK:pause 50
'----------- SHOW IDLE MESSAGE ----------------------------
gosub SHOW_IDLE:pause 50
'----------- SHOW IN MESSAGE ----------------------------
gosub SHOW_IN:pause 50
'----------- SHOW OUT MESSAGE ---------------------------
gosub SHOW_OUT:pause 50
'----------- SHOW CLEAR MESSAGE -------------------------
gosub SHOW_CLEAR:pause 50
'----------- SHOW ERROR MESSAGE -------------------------
gosub SHOW_ERROR:pause 50
'----------- SHOW ON MESSAGE ----------------------------
gosub SHOW_ON:pause 50
'----------- SHOW OFF MESSAGE ---------------------------
gosub SHOW_OFF:pause 50
'---------- SHOW RUNNING COUNTER ----------------------
for counter=0 to 255
gosub show_counter
next
'--------- FLASHING READY -------------------------------
#RDY
gosub SHOW_READY:pause 20:gosub SHOW_BLANK:pause 20:goto RDY

'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII

'--------------------------------------------------------
'----    TREIBER LED-DISPLAY MIT IIC-BUS SAA1064
'--------------------------------------------------------
#SHOW_COUNTER
DIGIT4=0
hunderter=counter/100:DECODE=hunderter:gosub DECODER:DIGIT3=DECODE
zehner=(counter-(hunderter*100))/10
DECODE=zehner:gosub DECODER:DIGIT2=DECODE
einer=counter-hunderter*100-zehner*10
DECODE=einer:gosub DECODER:DIGIT1=DECODE:goto SENDBUF
 '-------------------------------------------------------
#SHOW_BLANK
DIGIT4=0:DIGIT3=0:DIGIT2=0:DIGIT1=0:goto SENDBUF
#SHOW_IDLE
DIGIT4=I:DIGIT3=d:DIGIT2=L:DIGIT1=E:goto SENDBUF
#SHOW_IN
DIGIT4=I:DIGIT3=n:DIGIT2=0:DIGIT1=0:goto SENDBUF
#SHOW_OUT
DIGIT4=O:DIGIT3=U:DIGIT2=t:DIGIT1=0:goto SENDBUF
#SHOW_CLEAR
DIGIT4=C:DIGIT3=L:DIGIT2=r:DIGIT1=0:goto SENDBUF
#SHOW_READY
DIGIT4=r:DIGIT3=D:DIGIT2=y:DIGIT1=0:goto SENDBUF
#SHOW_ERROR
DIGIT4=E:DIGIT3=r:DIGIT2=r:DIGIT1=0:goto SENDBUF
#SHOW_ON
DIGIT4=O:DIGIT3=n:DIGIT2=0:DIGIT1=0:goto SENDBUF
#SHOW_OFF
DIGIT4=o:DIGIT3=F:DIGIT2=F:DIGIT1=0:goto SENDBUF
#SHOW_TEST
DIGIT4=&HFF:DIGIT3=&HFF:DIGIT2=&HFF:DIGIT1=&HFF:goto SENDBUF

'-----------------------------------------------------
'HHHHHHHHHH      IIC-BUS DRIVER      HHHHHHHHHHHHHHHHH
'------------------------------------------------------
#SENDBUF
gosub IICSTART:IICDATA=LEDWRITE:gosub IICSEND
IICDATA=0:gosub IICSEND:IICDATA=BRIGHTNES:gosub IICSEND
IICDATA=DIGIT1:gosub IICSEND:IICDATA=DIGIT2:gosub IICSEND
IICDATA=DIGIT3:gosub IICSEND:IICDATA=DIGIT4:gosub IICSEND
gosub IICSTOP:return
'-------------------------------------------
#IICSTART
SDA=off:SCL=off:return
#IICSTOP
SDA=off:SCL=on:SDA=on:return
#IICSEND
MASK=&H80
#OUTSHIFT
SDA=(IICDATA and MASK):SCL=on:SCL=off
MASK=MASK shr 1:if MASK<>0 then goto OUTSHIFT
'---- 9th CLOCK FOR ACKNOWLEDGE ----------
#ACKN
deact SDA:SCL=on:SCL=off:SDA=off:return
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
#DECODER 'DEZIMAL ZU 7 SEGMENT
on DECODE goto 0,1,2,3,4,5,6,7,8,9
#0
DECODE=&H3F:return
#1
DECODE=&H06:return
#2
DECODE=&H5B:return
#3
DECODE=&H4F:return
#4
DECODE=&H66:return
#5
DECODE=&H6D:return
#6
DECODE=&H7D:return
#7
DECODE=&H07:return
#8
DECODE=&H7F:return
#9
DECODE=&H6F:return
