'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'IIIIIIIIIIIIIII      DEMO ZUR C-CONTROL MICRO             IIIIIIIIIIII
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'(by DIE HARD  10.04)
'
' ANWENDUNG:   MICROMODUL  (19 83 81) ANSTEURUNG LCD AM APPLICATION BOARD
'              IR EMPFANG MIT IR MODUL (198860) oder TSOP 1638 
'-----------------------------------------------------------------------
' Sie sehen hier die Anwendung der C-Control MICRO mit einer PCF8574
' Porterweiterung. Der PCF8574 befindet sich auf dem IIC-BUS LCD MODUL
' bzw. auf dem MICROMODUL und steuert in diesem Fall das LCD des
' Application Board an.
' Der IIC-BUS liegt am MICROMODUL an den Ports 5 und 6.
' Wenn Sie allgemeine, nicht an das MICROMODUL adaptierte, Beispiele
' verwenden, so ndern sie bitte die Portdefinition
'  --- IIC INTERFACE  -------
'  define SDA      port[5]
'  define SCL      port[6]
' entsprechend, da diese Beispiele den IIC-BUS an PORT 2 u. 5 haben
' Dieses Beispiel spricht den PCF8574 auf dem MICROMODUL auf der 
' Adresse 01001110 an, alle Adress-Jumper auf dem MICROMODUL mssen daher
' abgezogen sein
'-----------------------------------------------------------------------
'
'-----------------------------------------------------------------------
' Beschreibung
' Ein kleines TOOL um die Codes zu lesen, die Ihre IR-Fernsteuerung sendet.
' Der Treiber erwartet den Eingang des IR-Empfngers an Port 4.
' Wenn Sie das IR Modul 198860 am Application-Board gesteck haben, mssen
' Sie PORT4 der MICRO mit PORT 2 auf der Busleiste des MICRO-MODULS verbinden.
' Die Ausgabe erfolgt auf das LCD am Application-Board 2.0 
'
'---------------------------------------------------------------------------
'
' !!!  DER TREIBER PASST NICHT ZUR MICRO MIT BETRIEBSSYSTEM-VERSION V 2.00 !!!
'
' Ein Tool um die OS-Version festzustellen finden Sieu.a. im Verzeichnis MICRO_TOOLS
'----------------------------------------------------------------------------
'-------------------------------------------------------------------
'Hier sehen Sie, welche PCF 8574 Ports dem LCD zugeordnet sind:
'Port 0  LCD DB4
'Port 1  LCD DB5
'Port 2  LCD DB6
'Port 3  LCD DB7
'Port 4  LCD R/W
'Port 5  LCD RS
'Port 6  LCD EN
'-------------------------------------------------------------------
'--------------------------
'------ I/O PORTS ---------
'--------------------------
'--- IIC INTERFACE  -------
define SDA      port[5]
define SCL      port[6]
'---- IR RECCEIER ---------
define IRIN      port[4]

'--------------------------
'------ SYSTEM MEMORY -----
'--------------------------
define COMMAND   byte[1]
define ADDRESS   byte[2]
'--- IIC INTERFACE  -------
define IICDATA      byte[3]
define DB0         bit[17]
define DB1         bit[18]
define DB2         bit[19]
define DB3         bit[20]
define DB4         bit[21]
define DB5         bit[22]
define DB6         bit[23]
define DB7         bit[24]
'--------------------------
define OUTBYTE      byte[4]
define LCDDATA      byte[5]
define BUF          byte[6]
define WADDRESS     byte[7]


'--- DEZIMAL CONVERTER ----
define value         byte[8]
define zehner        byte[9]
define einer         byte[10]

define LCDADDR  &B01001110

'---- ZEICHENSATZ DEFINITION -------------
define Z0&H30:define Z1&H31:define Z2&H32:define Z3&H33
define Z4&H34:define Z5&H35:define Z6&H36:define Z7&H37
define Z8&H38:define Z9&H39
define A&H41:define B&H42:define C&H43:define D&H44
define E&H45:define F&H46:define G&H47:define H&H48
define I&H49:define J&H4A:define K&H4B:define L&H4C
define M&H4D:define N&H4E:define O&H4F:define P&H50
define Q&H51:define R&H52:define S&H53:define T&H54
define U&H55:define V&H56:define W&H57:define X&H58
define Y&H59:define Z&H5A:define BLK&H20

'---------- IICBUS INIT ------------------
SDA=on:SCL=on
'---- PCF8574 LCD DRIVE INIT -------------
gosub lcd_init
'------ IR BACKGROUND RECEIVING INIT -----
SYS &HFD06
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'II          ANZEIGE IR-CODES                 II
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
pause 20
gosub LCD_CLR
LCDDATA=W:gosub lcd_writechar
LCDDATA=A:gosub lcd_writechar
LCDDATA=I:gosub lcd_writechar
LCDDATA=T:gosub lcd_writechar
LCDDATA=I:gosub lcd_writechar
LCDDATA=N:gosub lcd_writechar
LCDDATA=G:gosub lcd_writechar



#loop
gosub CLEAR_DATA
'----- WAITING FOR RECEIVED DATA -------
wait (COMMAND or ADDRESS)<>0
'----- DELETE TOGGLE BIT ---------------
ADDRESS=ADDRESS and &H1F
'-------------- SHOW RESULT --------------------
gosub LCD_CLR
LCDDATA=A:gosub lcd_writechar
LCDDATA=D:gosub lcd_writechar
LCDDATA=R:gosub lcd_writechar
LCDDATA=BLK:gosub lcd_writechar
value=ADDRESS:gosub SHOW
LCDDATA=BLK:gosub lcd_writechar
LCDDATA=C:gosub lcd_writechar
LCDDATA=M:gosub lcd_writechar
LCDDATA=D:gosub lcd_writechar
LCDDATA=BLK:gosub lcd_writechar
value=COMMAND:gosub SHOW
pause 10:gosub LCD_CLR:goto LOOP
'----------------------------------------------



'IIIIIIIIIIIII UNTERPROGRAMME IIIIIIIIIIIIIIIIIIIIIII
#SHOW
zehner=value/10:LCDDATA=zehner+&H30:gosub LCD_WRITECHAR
einer=value-(zehner*10):LCDDATA=einer+&H30:gosub LCD_WRITECHAR
return
'---------------------------------------
#CLEAR_DATA
COMMAND=0:ADDRESS=0:return
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII



'-------------------------------------------
'-- WRITE BYTE IN OUTBYTE TO PCF8574  ------
'-------------------------------------------
#WRITEBYTE
gosub IICSTART:IICDATA=WADDRESS:gosub IICSEND
IICDATA=OUTBYTE:gosub IICSEND:gosub IICSTOP:return
'-------------------------------------------
#IICSTART
SDA=off:SCL=off:return
#IICSTOP
SDA=off:SCL=on:SDA=on:return
#IICSEND
SDA=DB7:SCL=on:SCL=off
SDA=DB6:SCL=on:SCL=off
SDA=DB5:SCL=on:SCL=off
SDA=DB4:SCL=on:SCL=off
SDA=DB3:SCL=on:SCL=off
SDA=DB2:SCL=on:SCL=off
SDA=DB1:SCL=on:SCL=off
SDA=DB0:SCL=on:SCL=off
'---- 9th CLOCK FOR ACKNOWLEDGE ----------
deact SDA:SCL=on:SCL=off:SDA=off:return

'---------------------------------------
'------------- LCD ROUTINES -------------
'----------------------------------------
#LCD_INIT
WADDRESS=LCDADDR
OUTBYTE=0:gosub WRITEBYTE
LCDDATA=&H38:gosub LCD_WRITECMD
OUTBYTE= &B00000010:gosub WRITEBYTE '$02 to LCD
OUTBYTE= &B01000010:gosub WRITEBYTE '$02 with CLOCK
OUTBYTE= &B00000010:gosub WRITEBYTE
LCDDATA=&H28:gosub LCD_WRITECMD
LCDDATA=&H0C:gosub LCD_WRITECMD
#LCD_CLR
LCDDATA=&H02:gosub LCD_WRITECMD
LCDDATA=&H01:gosub LCD_WRITECMD
return
#L1_GOTOPOS
LCDDATA=LCDDATA +&H7F:goto LCD_WRITECMD
#L2_GOTOPOS
LCDDATA=LCDDATA +&HBF:goto LCD_WRITECMD
#LCD_WRITECMD
BUF = off:goto LCD_WRITE
#LCD_WRITECHAR
BUF = &B00100000
#LCD_WRITE
WADDRESS=LCDADDR
'--------- WRITE HI NIBBLE -------------
OUTBYTE=BUF or (LCDDATA shr 4):gosub WRITEBYTE      'DATA TO PORT
OUTBYTE=OUTBYTE or &B01000000:gosub WRITEBYTE           'STROBE HI
OUTBYTE=OUTBYTE and &B10111111:gosub WRITEBYTE          'STROBE LO
'--------- WRITE LO NIBBLE -------------
OUTBYTE=BUF or (LCDDATA and &H0F):gosub WRITEBYTE'DATA TO PORT
OUTBYTE=OUTBYTE or &B01000000:gosub WRITEBYTE           'STROBE HI
OUTBYTE=OUTBYTE and &B10111111:gosub WRITEBYTE          'STROBE LO
return

SYSCODE "RC5_P0.s19"
